
generate_paired_realdata<-function(dn,np,algoId,scoreId,dataType,alpha,penaltyDiscount){
# function generate two datasets that is different from the real dataset where np variable were permuted
    
    d0<-readRDS(paste0('../Data/',dn,'.rds'))
    if ((dn=='P3TLH_Hepatocytes')|(dn=='Ind4')){
	d0<-log(d0+0.001)
	}
    idx<-sample(1:dim(d0)[2],2*np,replace=FALSE)
    gen1<-list()
    gen1$D<-d0
    gen1$D[,idx[1:np]]<-as.data.frame(apply(gen1$D[,idx[1:np],drop=FALSE],2,
                              function(x){
                                  sample(x,dim(d0)[1],replace=FALSE)
                              }))
    
    obj<-tetradrunner(df=gen1$D,
             algoId=algoId,
             scoreId=scoreId,
             dataType=dataType,
             alpha=alpha,
             penaltyDiscount=penaltyDiscount,
             verbose=FALSE)
    gen1$adjM<-tetrad_to_adjM(obj)
    gen1$sk<-((gen1$adjM+t(gen1$adjM))>0)+0
        
    gen2<-list()
    gen2$D<-d0
    gen2$D[,idx[(np+1):(2*np)]]<-as.data.frame(apply(gen2$D[,idx[(np+1):(2*np)],drop=FALSE],2,
                              function(x){
                                  sample(x,dim(d0)[1],replace=FALSE)
                              }))
    obj<-tetradrunner(df=gen2$D,
             algoId=algoId,
             scoreId=scoreId,
             dataType=dataType,
             alpha=alpha,
             penaltyDiscount=penaltyDiscount,
             verbose=FALSE)
    gen2$adjM<-tetrad_to_adjM(obj)
    gen2$sk<-((gen2$adjM+t(gen2$adjM))>0)+0
    out<-list(gen1=gen1,gen2=gen2)
    return(out)
}
