#!/usr/bin/env Rscript
args = commandArgs(trailingOnly=TRUE)
dn<-args[1]
np<-as.numeric(args[2])
s_rep<-as.numeric(args[3])

algoId<-'fges'
scoreId<-'sem-bic'
dataType<-'continuous'
alpha<-0.05
penaltyDiscount<-5

#setwd('/media/sf_Projects/NetworkComparison/Code')
#dirn<-paste0('/home/sisima/sisima/JP/',dn,np,s_rep,'/.systemPrefs/')
#dir.create(dirn,recursive=TRUE)
#jstr<-c('-Xmx16000m',paste0('-Djava.util.prefs.userRoot=',dirn),paste0('-Djava.util.prefs.systemRoot=',dirn))
#options(java.parameters=jstr)
#print(getOption('java.parameters'))

source('graph_tools.R')
source('generate_paired_realdata.R')
library('rcausal')

e_rep<-s_rep
r_o2<-c(0.1,0.2,0.5,1)
pname<-paste0('../Results/rwd/',dn,'_np',np,'/')

dir.create(pname)
for (i in s_rep:e_rep){
    if (!file.exists(paste0(pname,'/gs_e',i))){

        out<-generate_paired_realdata(dn,np,algoId,scoreId,
                                      dataType,alpha,penaltyDiscount)
        gen1<-out$gen1
        gen2<-out$gen2
        save(file=paste0(pname,'/gs_e',i),gen1,gen2)
    } else {
        load(file=paste0(pname,'/gs_e',i))
    }
    n_o1<-ceiling(dim(gen1$D)[1]*0.6)

    for (n1 in n_o1){
        if (!file.exists(paste0(pname,'/res_e',i,'_g1_n',n1,'_bs'))){
            out1<-run_cds(df=gen1$D[1:n1,],
             algoId=algoId,
             scoreId=scoreId,
             dataType=dataType,
             alpha=alpha,
             penaltyDiscount=penaltyDiscount,
             mode='bootstrap',
             nr=50)
            save(file=paste0(pname,'/res_e',i,'_g1_n',n1,'_bs'),out1)
        }
        
        for (n2 in ceiling(r_o2*n1)){
            if (!file.exists(paste0(pname,'/res_e',i,'_g2_n',n2,'_bs'))){
                out2<-run_cds(df=gen2$D[1:n2,],
                              algoId=algoId,
                              scoreId=scoreId,
                              dataType=dataType,
                              alpha=alpha,
                              penaltyDiscount=penaltyDiscount,
                              mode='bootstrap',
                              nr=50)
                save(file=paste0(pname,'/res_e',i,'_g2_n',n2,'_bs'),out2)
            }
            if (!file.exists(paste0(pname,'/res_e',i,'_g1_n',n1,'_rs',n2))){
                if (n1!=n2){
		out1<-run_cds(df=gen1$D[1:n1,],
                              algoId=algoId,
                              scoreId=scoreId,
                              dataType=dataType,
                              alpha=alpha,
                              penaltyDiscount=penaltyDiscount,
                              mode='resample',
                              nr=50,ns=n2)
                save(file=paste0(pname,'/res_e',i,'_g1_n',n1,'_rs',n2),
                     out1)
		}
            }
        }
    }

}

